PROGRAM Seriova_linka;

USES
  Crt, ibmcom;

{Read a key from the keyboard.  If it's an ordinary key, the ascii code
is returned in ch1 and ch2 is #0.  If it's a function key, ch1 is 0 and
the scan code is in ch2.}

PROCEDURE read_key (VAR ch1, ch2: Char);
BEGIN
  ch1 := ReadKey;
  IF ch1 = #0 THEN
    ch2 := ReadKey
  ELSE
    ch2 := #0;
END;


CONST
  port          = 1;
  initial_speed = 19200;

VAR
  result   : Word;
  exit_prog: Boolean;
  ch1, ch2 : Char;
  ch3      : Char;

BEGIN

clrscr;

Writeln('Cteni ze serioveho portu');
write('Port: ',port);
writeln(' Nastavena rychlost: ',initial_speed);
writeln('Stiskem Alt-X ukoncite program');


  ComInstall (port, result);
  IF result <> 0 THEN
    BEGIN
    CASE result OF
      1: Writeln ('Chybne cislo portu: ', port);
      2: Writeln ('Zadny hardware na portu ', port);
      3: Writeln ('Driver je uz jednou instalovan');
    ELSE
      Writeln ('Neocekavana chyba v ComInstall', result);
      END;
    Exit;
    END;
  ComRaiseDTR;                 {nastavi DTR}
  ComSetSpeed (initial_speed);
  ComSetParity (ComNone, 1);   {zadna parita,1 stop bit}
  exit_prog := False;

  REPEAT
    IF KeyPressed THEN
      BEGIN
      read_key (ch1, ch2);
      CASE ch2 OF
          #45: {Alt-X}
            exit_prog := True;
          END;
      END;
    ch3 := ComRx;
    IF ch3 <> #0 THEN
      Write (ch3);
  UNTIL exit_prog;
END.
